<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import type { Member } from '@/types/Member'
import { useMembersStore } from '@/stores/member'
import type { VForm } from 'vuetify/components'
import { useLoadingStore } from '@/stores/loading'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Email',
    key: 'email'
  },
  {
    title: 'Username',
    key: 'username'
  },
  {
    title: 'Password',
    key: 'password'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Tel',
    key: 'tel'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  {
    title: 'Point',
    key: 'point'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const membersStore = useMembersStore()

const loadingStore = useLoadingStore()
const form = ref(false)
const refform = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

async function editItem(item: Member) {
  if (!item.id) return
  await membersStore.getMember(item.id)
  dialog.value = true
}

async function deleteItem(item: Member) {
  if (!item.id) return
  await membersStore.getMember(item.id)
  dialogDelete.value = true
}

async function deleteItemConfirm() {
  await membersStore.deleteMember()
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    membersStore.clearForm()
  })
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    membersStore.clearForm()
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  await membersStore.saveMember()
  closeDialog()
}

onMounted(async () => {
  await membersStore.getMembers()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="membersStore.members">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #212121; color: white">
          <v-toolbar-title>Member</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="600">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
                New Member
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="6" sm="12" md="6">
                        <v-text-field
                          v-model="membersStore.editedMember.username"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Username"
                          placeholder="Enter Username"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="12" md="6">
                        <v-text-field
                          v-model="membersStore.editedMember.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Email"
                          placeholder="Enter Email"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="12" md="6">
                        <v-text-field
                          v-model="membersStore.editedMember.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Password"
                          placeholder="Enter Password"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="12" md="6">
                        <v-text-field
                          v-model="membersStore.editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Name"
                          placeholder="Enter Member Name"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="membersStore.editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          clearable
                          label="Tel"
                          placeholder="Enter Member Tel"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="membersStore.editedMember.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Point"
                          placeholder="Enter Member Point"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="4" md="4" class="mx-auto">
                        <v-combobox
                          v-model="membersStore.editedMember.gender"
                          class="mb-2"
                          clearable
                          label="Gender"
                          prepend-inner-icon="mdi-gender-male-female"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          :items="[
                            { title: 'Male', value: 'Male' },
                            { title: 'Female', value: 'Female' },
                            { title: 'Others', value: 'Others' }
                          ]"
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-file-input
                          v-model="membersStore.editedMember.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 5000000 ||
                                'Avatar size should be less than 5 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg"
                          label="Avatar"
                          placeholder="Pick an avatar"
                          prepend-icon="mdi-camera"
                        ></v-file-input>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-img
                          :src="
                            'http://localhost:3000/images/members/' +
                            membersStore.editedMember.image
                          "
                          width="100"
                        ></v-img>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please Fill Data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/members/' + item.image" width="100"></v-img>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="membersStore.getMembers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped>
.grey-background {
  background-color: #e0e0e0;
}
</style>
